import { OnDestroy } from '@angular/core';
import { Store } from '../../store';
import { NgxsConfig } from '../../symbols';
/**
 * Allows the select decorator to get access to the DI store, this is used internally
 * in `@Select` decorator.
 */
export declare class SelectFactory implements OnDestroy {
    static store: Store | null;
    static config: NgxsConfig | null;
    constructor(store: Store, config: NgxsConfig);
    ngOnDestroy(): void;
}
