/**
 * Returns the type from an action instance/class.
 * @ignore
 */
export declare function getActionTypeFromInstance(action: any): string | undefined;
/**
 * Matches a action
 * @ignore
 */
export declare function actionMatcher(action1: any): (action2: any) => boolean;
/**
 * Set a deeply nested value. Example:
 *
 *   setValue({ foo: { bar: { eat: false } } },
 *      'foo.bar.eat', true) //=> { foo: { bar: { eat: true } } }
 *
 * While it traverses it also creates new objects from top down.
 *
 * @ignore
 */
export declare const setValue: (obj: any, prop: string, val: any) => any;
/**
 * Get a deeply nested value. Example:
 *
 *    getValue({ foo: bar: [] }, 'foo.bar') //=> []
 *
 * @ignore
 */
export declare const getValue: (obj: any, prop: string) => any;
/**
 * Simple object check.
 *
 *    isObject({a:1}) //=> true
 *    isObject(1) //=> false
 *
 * @ignore
 */
export declare const isObject: (item: any) => boolean;
/**
 * Deep merge two objects.
 *
 *    mergeDeep({a:1, b:{x: 1, y:2}}, {b:{x: 3}, c:4}) //=> {a:1, b:{x:3, y:2}, c:4}
 *
 * @param base base object onto which `sources` will be applied
 */
export declare const mergeDeep: (base: any, ...sources: any[]) => any;
